export declare const name: string;
export declare const version: string;
export declare const description: string;
export declare const main: string;
export declare const scripts: {
    "build": string;
    "build:watch": string;
    "start": string;
    "start:cli": string;
    "dev:cli": string;
    "dev": string;
    "lint": string;
    "lint:fix": string;
    "test": string;
    "ship": string;
};
export declare const repository: {
    "type": string;
    "url": string;
};
export declare const keywords: string[];
export declare const author: string;
export declare namespace bin {
    export const bulkmail: string;
    export const bulkmaildev: string;
}
export declare const preferGlobal: boolean;
export declare const license: string;
export declare namespace bugs {
    export const url: string;
}
export declare const homepage: string;
export declare const devDependencies: {
    "@types/csvtojson": string;
    "@types/node": string;
    "@types/node-cron": string;
    "@types/nodemailer": string;
    "@typescript-eslint/eslint-plugin": string;
    "@typescript-eslint/parser": string;
    "babel-eslint": string;
    "concurrently": string;
    "eslint": string;
    "eslint-config-airbnb": string;
    "eslint-config-prettier": string;
    "eslint-config-wesbos": string;
    "eslint-plugin-html": string;
    "eslint-plugin-import": string;
    "eslint-plugin-jsx-a11y": string;
    "eslint-plugin-prettier": string;
    "eslint-plugin-react": string;
    "eslint-plugin-react-hooks": string;
    "nodemon": string;
    "prettier": string;
    "typescript": string;
    "typings": string;
};
export declare const dependencies: {
    "chalk": string;
    "clear": string;
    "commander": string;
    "cron-parser": string;
    "csvtojson": string;
    "figlet": string;
    "ncp": string;
    "node-cron": string;
    "nodemailer": string;
    "path": string;
    "replace-string": string;
    "simplesmtp": string;
    "socks": string;
    "strip-json-comments": string;
    "tslib": string;
};
