"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var checkConnection_1 = require("./checkConnection");
var stringProcessor_1 = require("./stringProcessor");
function isConnectionPossible(credentials) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var host, port, secureConnection, email, password, proxy, smtpOptions, isSuccessful;
        return tslib_1.__generator(this, function (_a) {
            host = credentials.host, port = credentials.port, secureConnection = credentials.secureConnection, email = credentials.email, password = credentials.password, proxy = credentials.proxy;
            smtpOptions = {
                host: stringProcessor_1.default(host, process.env),
                port: parseInt(stringProcessor_1.default(port.toString(), process.env)),
                secureConnection: stringProcessor_1.default(secureConnection.toString(), process.env) == 'true',
                auth: {
                    user: stringProcessor_1.default(email, process.env),
                    pass: stringProcessor_1.default(password, process.env),
                },
                proxy: proxy ? stringProcessor_1.default(proxy, process.env) : null,
            };
            isSuccessful = new Promise(function (resolve, reject) {
                checkConnection_1.default(smtpOptions, function (error, success) {
                    if (success)
                        resolve(true);
                    if (error)
                        reject(false);
                });
            });
            return [2, isSuccessful];
        });
    });
}
exports.default = isConnectionPossible;
//# sourceMappingURL=isConnectionPossible.js.map